LevelX = Core.class(Sprite)

function LevelX:init()
	self.isfullscreen = false -- press "F" to go fullscreen
	-- cbump
	local cbump = require "cbump"
	self.cworld = cbump.newWorld() -- default is 64*64
	-- some lists
	self.cworld.fixednmes = {}
	self.cworld.walkingnmes = {}
	self.cworld.flyingnmes = {}
	-- we build the levels in Tiled
	self.tiled_level = Tiled_Levels.new(self.cworld, tiled_levels[g_currentlevel])
	-- hack: the projectiles layer
	self.cworld.projectileslayer = self.tiled_level.mg_actors
	-- player 1 lose fx
	self.cworld.losescreen = Bitmap.new(Texture.new("tiled/levels/grounds/Abstract_004_SPEC.png"))
	self.cworld.losescreen:setAnchorPoint(0.5, 0.5)
	self.cworld.losescreen:setAlpha(0.1)
	self.cworld.losescreen:setVisible(false)
	-- a camera (gcam by rrraptor)
	self.cworld.gcam = GCam.new(self.tiled_level.camera)
	self.cworld.gcam:setAutoSize(true)
	self.cworld.gcam:setZoom(0.6) -- 0.6, 0.1 for debuging
--	self.cworld.gcam:setAnchor(0.5, 0.5)
	local gcamleft = 64*6.6 -- 0.5 = 64*9.9
	local gcamtop = 64*6.5 -- 0.5 = 64*4.5
	local gcamright = self.tiled_level.mapwidth - gcamleft
	local gcambottom = self.tiled_level.mapheight - 64*0 -- 0.5 = -64*5.6
	self.cworld.gcam:setBounds(gcamleft, gcamtop, gcamright, gcambottom)
	self.cworld.gcam:setDeadSize(64*1, 64*7, -64*0.8) -- w, h, offset
	self.cworld.gcam:setSoftSize(64*1*2, 64*7*2.6) -- w, h
	self.cworld.gcam:setFollow(self.cworld.player1)
--	self.cworld.gcam:setDebug(true)
	application:enableDrawInfo(vector(1, 1, 0, 1)) -- APPLICATION:ENABLEDRAWINFO
	-- HUD
	local function map(v, minSrc, maxSrc, minDst, maxDst, clampValue)
		local newV = (v - minSrc) / (maxSrc - minSrc) * (maxDst - minDst) + minDst
		return not clampValue and newV or clamp(newV, minDst >< maxDst, minDst <> maxDst)
	end
	self.cworld.hud = Sprite.new()
	-- hud lives
	self.cworld.hudlives = {}
	local pixellife
	for i = 1, self.cworld.player1.currlives do
		pixellife = Pixel.new(0xffff00, 0.8, 24, 24)
		if i == 1 then pixellife:setPosition(24, 24)
		else pixellife:setPosition(24*i+13.5*(i-1), 24)
		end
		self.cworld.hud:addChild(pixellife)
		self.cworld.hudlives[i] = pixellife
	end
	-- hud health
	local hudhealthwidth = map(self.cworld.player1.currhealth, 0, self.cworld.player1.totalhealth, 0, 100)
	self.cworld.hudhealth = Pixel.new(0x00ff00, 0.7, hudhealthwidth, 14)
	self.cworld.hudhealth:setPosition(24, 55)
	self.cworld.hud:addChild(self.cworld.hudhealth)
	-- gradient bg
	local pixel = Pixel.new(0xffffff, 1, self.tiled_level.mapwidth, self.tiled_level.mapheight) -- set a white color to start with
	pixel:setAnchorPoint(0.5, 0.5)
	pixel:setPosition(self.tiled_level.mapwidth/2, self.tiled_level.mapheight/2)
	pixel:setColor(0x0, 1, 0x07181E, 1, 90) -- a gradient set horizontally
	-- stars 2
	local spritestars = Sprite.new()
	for i = 1, 512 do -- 500
		local s=Shape.new()
		s:setLineStyle(2, 0xffffff)
		s:moveTo(0, 0)
		s:lineTo(1, 1)
		s:endPath()
		s:setPosition(math.random(0, myappwidth), math.random(0, myappheight))
		s:setScale(math.random(5, 25) / 10)
		s:setAlpha(math.random(10, 50) / 50) -- /100
		spritestars:addChild(s)
	end
	local rtstars = RenderTarget.new(myappwidth, myappheight, nil, true, nil, nil, nil, false) -- bug
	rtstars:draw(spritestars)
	rtstars:save("|T|bgstars.png")
	local texstars = Texture.new("|T|bgstars.png", nil, {wrap=TextureBase.REPEAT, extend=false})
	self.bgimgstars = Pixel.new(texstars, myappwidth, myappheight)
	self.bgimgstars:setAnchorPoint(0.5, 0.5)
	local texscale = 1
	self.bgimgstars:setTextureScale(texscale, texscale)
	self.bgimgstars:setColorTransform(7/255, 221/255, 219/255, 1)
	-- parallax
	local bgtex = Texture.new("gfx/parallax_bgs/cero_0001gx01.png", true, {wrap=TextureBase.REPEAT, extend=false})
	self.bgimg = Pixel.new(bgtex, myappwidth, bgtex:getHeight())
	self.bgimg:setAnchorPoint(0.5, 0.5)
	self.bgimg2 = Pixel.new(bgtex, myappwidth, bgtex:getHeight())
	self.bgimg2:setAnchorPoint(0.5, 0.5)
	self.bgimg:setColorTransform(8/255, 96/255, 198/255, 1)
	self.bgimg2:setTextureScale(texscale, texscale)
	self.bgimg2:setColorTransform(55/255, 186/255, 217/255, 1)
	-- position
	self.bgimgstars:setPosition(myappwidth/2, myappheight/2)
	self.bgimg:setPosition(myappwidth/2, 7*myappheight/10)
	self.bgimg2:setPosition(myappwidth/2, 8*myappheight/10)
	-- order
	self:addChild(pixel)
	self:addChild(self.bgimgstars)
	self:addChild(self.bgimg)
	self:addChild(self.bgimg2)
	self.tiled_level.mg_actors:addChild(self.cworld.losescreen)
	self:addChild(self.cworld.gcam)
	self:addChild(self.cworld.hud)
	-- player1 listeners
	self:addEventListener(Event.KEY_DOWN, self.cworld.player1.onKeyDown, self.cworld.player1)
	self:addEventListener(Event.KEY_UP, self.cworld.player1.onKeyUp, self.cworld.player1)
	-- listeners
	self:addEventListener("enterBegin", self.onTransitionInBegin, self)
	self:addEventListener("enterEnd", self.onTransitionInEnd, self)
	self:addEventListener("exitBegin", self.onTransitionOutBegin, self)
	self:addEventListener("exitEnd", self.onTransitionOutEnd, self)
end

-- game loop
local dt
local bgangle = 0
local camposx
function LevelX:onEnterFrame(e)
	dt = e.deltaTime
	if self.cworld.player1.currlives > 0 then
		-- bg parallax
		camposx = self.cworld.gcam.x
		bgangle -= dt * 1.5 -- 1.5, 0.4
		self.bgimgstars:setTexturePosition(bgangle, 0)
		self.bgimg:setTexturePosition(128*0-camposx*0.1, -1) -- -1 to get rid of the top bleeding
		self.bgimg2:setTexturePosition(128*2-camposx*0.2, -1) -- -1 to get rid of the top bleeding
		-- gcam
		self.cworld.gcam:update(dt) -- e.deltaTime 1/60
	end
end

-- event listeners
function LevelX:onTransitionInBegin() self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self) end
function LevelX:onTransitionInEnd() self:myKeysPressed() end
function LevelX:onTransitionOutBegin() self:removeAllListeners() end
function LevelX:onTransitionOutEnd() end

-- keys handler
function LevelX:myKeysPressed()
	local mouseposx, mouseposy = application:get("cursorPosition")
--	print(mouseposx, mouseposy)
	-- the keys
	self:addEventListener(Event.KEY_DOWN, function(e)
		if e.keyCode == KeyCode.BACK or e.keyCode == KeyCode.ESC then -- mobiles and desktops
			scenemanager:changeScene("levelX", 1, transitions[2], easings[2])
		end
		-- modifier
		local modifier = application:getKeyboardModifiers()
		local alt = (modifier & KeyCode.MODIFIER_ALT) > 0
		-- switch full screen
		if (alt and e.keyCode == KeyCode.ENTER) or e.keyCode == KeyCode.F then
			-- store curr mouse pos
			self.isfullscreen = not self.isfullscreen
			application:setFullScreen(self.isfullscreen)
			if self.isfullscreen then application:set("cursorPosition", 0, 0)
			else application:set("cursorPosition", mouseposx, mouseposy)
			end
		end
	end)
end
