SCollectible = Core.class(Sprite) -- don't need to put in lists

function SCollectible:init(xcworld, xparams)
	self.cworld = xcworld
	-- system
	self.iscollectible = true -- id, IMPORTANT! XXX
	-- params
	local params = xparams or {}
	params.scalex = xparams.scalex or 1
	params.scaley = xparams.scaley or params.scalex
	params.animspeed = xparams.animspeed or 1
	-- self
	self.x = xparams.x
	self.y = xparams.y
	self.version = xparams.version
	self.scalex = params.scalex
	self.scaley = params.scaley
	-- animations (creates the bitmap)
	self.hasanims = params.hasanims
	self.curranim = ""
	self.frame = 0
	self.animspeed = params.animspeed
	self.animtimer = self.animspeed
	-- animation functions
	SPlayables.cutSpritesheet(self, xparams.spritesheetpath, xparams.cols, xparams.rows)
	for i = 1, #xparams.animations do
		SPlayables.createAnim(self,
			xparams.animations[i][1], -- anim name
			xparams.animations[i][2], -- anim start
			xparams.animations[i][3] -- anim end
		)
	end
	-- the bitmap
	self.bmp = Bitmap.new(self.animsimgs[1]) -- starting bmp texture (from playables class)
	self.bmp:setAnchorPoint(0.5, 0.5)
	self.bmp:setScale(self.scalex, self.scaley)
	local imgoffsetx, imgoffsety = 0, 0
	local bodyoffsetx, bodyoffsety = 0, 0
	self.w = self.bmp:getWidth() + bodyoffsetx
	self.h = self.bmp:getHeight() + bodyoffsety
	-- set position inside sprite
	self.bmp:setPosition(self.w / 2 + imgoffsetx / 2, self.h / 2 + imgoffsety / 2)
	-- our sprite is ready
	self.sprite = Sprite.new()
	self.sprite:addChild(self.bmp)
	if xparams.sdebug then -- collisions debugging
		local mypixel = Pixel.new(xparams.sdebug, 0.5, self.w, self.h)
		self.sprite:addChild(mypixel)
	end
	self.sprite:setPosition(self.x, self.y)
	self:addChild(self.sprite)
	-- listeners
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

-- game loop
local visibilitydist = myappwidth*1
local dx, dy
local player1
function SCollectible:onEnterFrame(e)
	player1 = self.cworld.player1
	dx, dy = self.x - player1.x, self.y - player1.y
	if (((dx * dx) + (dy * dy)) ^0.5) < visibilitydist then
		if self.isdirty then
			-- dirty
			self.isdirty = false
			self.sprite:getParent():removeChild(self.sprite) -- remove sprite from layer
			self.cworld:remove(self) -- remove from cbump world
		else
			-- action
			if self.hasanims then SPlayables.playAnim(self, e.deltaTime) end
		end
	end
end
