SPlayables = Core.class(Sprite) -- don't need to put in lists

function SPlayables:init(xcworld, xparams)
	self.cworld = xcworld
	-- params
	if xparams.shape then -- no anims
	else -- anims
		local spritesheetpath = xparams.spritesheetpath or nil
		local cols = xparams.cols or 1
		local rows = xparams.rows or 1
		self.x = xparams.x
		self.y = xparams.y
		-- animation step1: cut spritesheet and put each image in a table
		self:cutSpritesheet(spritesheetpath, cols, rows)
	end
	-- event listeners
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

-- game loop
function SPlayables:onEnterFrame(e)
	if self.isactive then
		-- physics flags
		self.isstepcontacts = false
		self.isfloorcontacts = false
		self.iswallcontacts = false
		self.isladdercontacts = false
		self.isptpfcontacts = false
		self.ismvpfcontacts = false
		self.isspringcontacts = false
		--  _____ ____  _      _      _____  _____ _____ ____  _   _ 
		-- / ____/ __ \| |    | |    |_   _|/ ____|_   _/ __ \| \ | |
		--| |   | |  | | |    | |      | | | (___   | || |  | |  \| |
		--| |   | |  | | |    | |      | |  \___ \  | || |  | | . ` |
		--| |___| |__| | |____| |____ _| |_ ____) |_| || |__| | |\  |
		-- \_____\____/|______|______|_____|_____/|_____\____/|_| \_|
		-- ______ _____ _   _______ ______ _____  
		--|  ____|_   _| | |__   __|  ____|  __ \ 
		--| |__    | | | |    | |  | |__  | |__) |
		--|  __|   | | | |    | |  |  __| |  _  / 
		--| |     _| |_| |____| |  | |____| | \ \ 
		--|_|    |_____|______|_|  |______|_|  \_\
		local function collisionfilter(item, other) -- "touch", "cross", "slide", "bounce"
			if other.isdoor then return "slide"
			elseif other.isfloor then return "slide"
			elseif other.isblock then -- block actors when was going off up ladders
				if item.wasonladder then
					if item.vy < 0 then -- going up
						return "bounce"
					end
				end
			elseif other.isptpf then
				if item.isdown and item.isup then -- prevents ptpf while holding both up and down keys XXX
					item.wasdown = true
					item.wasup = true
				end
				if item.isdown and not item.wasdown then
					return "cross"
				end
				if item.vy > 0 then -- going down
					local itembottom = item.y + item.h
					local otherbottom = other.y
					if itembottom <= otherbottom then return "slide" end
				end
				if item.iswalkingnme and item.breed == "C" then -- new 20230724 XXX
					return "slide"
				end
			elseif other.ismvpf then -- can pass through
				if item.isdown and item.isup then -- prevents pt mvpf while holding both up and down keys
					item.wasdown = true
					item.wasup = true
				end
				if item.isdown and not item.wasdown then -- pass through
					return "cross"
				end
				if item.vy > 0 then -- going down
					local itembottom = item.y + item.h
					local otherbottom = other.y + 4 -- 2, some mvpf margin, magik XXX
					if itembottom <= otherbottom then return "slide" end
				end
			elseif other.isspring then return "slide"
--			elseif other.istunnelfloor then return "cross" -- "slide" XXX -- to jump between tigh space
--			elseif other.isstep then return "cross" -- CBump stairs effect ;-)
--			elseif other.isplayer1 then return "cross"
--			elseif other.isnme then return "cross"
--			elseif other.iscollectible then return "cross"
--			elseif other.isladder then return "cross"
			else return "cross"
			end
		end
		--  _____ ____  _    _ __  __ _____  
		-- / ____|  _ \| |  | |  \/  |  __ \ 
		--| |    | |_) | |  | | \  / | |__) |
		--| |    |  _ <| |  | | |\/| |  ___/ 
		--| |____| |_) | |__| | |  | | |     
		-- \_____|____/ \____/|_|  |_|_|     
		local goalx = self.x + self.vx
		local goaly = self.y + self.vy
		local nextx, nexty, collisions, len = self.cworld:move(self, goalx, goaly, collisionfilter)
		--  _____ ____  _      _      _____  _____ _____ ____  _   _  _____ 
		-- / ____/ __ \| |    | |    |_   _|/ ____|_   _/ __ \| \ | |/ ____|
		--| |   | |  | | |    | |      | | | (___   | || |  | |  \| | (___  
		--| |   | |  | | |    | |      | |  \___ \  | || |  | | . ` |\___ \ 
		--| |___| |__| | |____| |____ _| |_ ____) |_| || |__| | |\  |____) |
		-- \_____\____/|______|______|_____|_____/|_____\____/|_| \_|_____/ 
		-- we handle ALL collisions here!
		for i = 1, len do
			local col = collisions[i]
			if col.other.iswall then
				col.item.iswallcontacts = true
			end
			if col.other.isladder then
				col.item.currcoyotetimer = col.item.coyotetimer + 4 -- magik XXX
				col.item.isladdercontacts = true
			end
			if col.other.isblock then
				if col.item.wasonladder then
					col.item.vy *= -0.01
					col.item.wasonladder = false
				end
			end
			if col.other.isstep then -- CBump stairs effect ;-)
				col.item.isstepcontacts = true
				col.item.currcoyotetimer = col.item.coyotetimer -- magik, new 20230315 XXX
				col.item.isfloorcontacts = false
			end
			if col.other.istunnelfloor then
				if self.isup and (self.isleft or self.isright) then
					col.item.wasup = false -- new 20230315 XXX
					col.item.currcoyotetimer = col.item.coyotetimer -- magik XXX
--					col.item.vy = -col.item.jumpspeed*0.1
				end
			end
			if col.other.ismvpf then -- controls movements on mvpfs or not?
--				print("col.other.ismvpf", e.deltaTime)
				col.item.currcoyotetimer = col.item.coyotetimer + 4 -- magik XXX
				if col.item.vy > 0 then -- going down
					local itembottom = col.item.y + col.item.h
					local otherbottom = col.other.y + 3 -- 2, some margin
					if itembottom < otherbottom then
						col.item.ismvpfcontacts = true
					end
				end
				if col.item.isleft and not col.item.isright and col.other.vx < 0 then
					col.item.vx = -col.item.speed*0.9
				elseif col.item.isright and not col.item.isleft and col.other.vx < 0 then
					col.item.vx = col.item.speed*0.9
				elseif (col.item.isleft and col.item.isright) and col.other.vx < 0 then
					col.item.vx = col.other.vx
				elseif not(col.item.isleft and col.item.isright) and col.other.vx < 0 then
					col.item.vx = col.other.vx
				elseif col.item.isleft and not col.item.isright and col.other.vx > 0 then
					col.item.vx = -col.item.speed*0.9
				elseif col.item.isright and not col.item.isleft and col.other.vx > 0 then
					col.item.vx = col.item.speed*0.9
				elseif (col.item.isleft and col.item.isright) and col.other.vx > 0 then
					col.item.vx = col.other.vx
				elseif not (col.item.isleft and col.item.isright) and col.other.vx > 0 then
					col.item.vx = col.other.vx
				elseif col.item.isleft and not col.item.isright and col.other.vx == 0 then
					col.item.vx = -col.item.speed*0.9
				elseif col.item.isright and not col.item.isleft and col.other.vx == 0 then
					col.item.vx = col.item.speed*0.9
				elseif (col.item.isleft and col.item.isright) and col.other.vx == 0 then
					col.item.vx = 0
				elseif not (col.item.isleft and col.item.isright) and col.other.vx == 0 then
					col.item.vx = 0
				end
			end
			-- walking nmes
			if col.item.iswalkingnme then
--				if col.other.isplayer1 then col.other.isdirty = true end
				if col.normal.x ~= 0 and not col.other.isplayer1 and not col.other.isnme then -- change direction upon hitting obstacles
					col.item.isleft, col.item.isright = not col.item.isleft, not col.item.isright
				end
			end
			-- COLLISION FROM TOP
			if col.normal.y == -1 then
				if col.other.isfloor then
					col.item.vy = 0 -- reset velocity y (don't accumulate gravity)
					col.item.isfloorcontacts = true
					col.item.currcoyotetimer = col.item.coyotetimer
				elseif col.other.isptpf then
					col.item.vy = 0 -- reset velocity y (don't accumulate gravity)
					col.item.isptpfcontacts = true
					col.item.currcoyotetimer = col.item.coyotetimer
				elseif col.other.ismvpf then
					--col.item.vy = 0 -- don't reset velocity y because platform can move on y axis
					col.item.isstepcontacts = false
					col.item.ismvpfcontacts = true
				elseif col.other.isspring then
					col.item.isspringcontacts = true
				elseif col.other.isnme and not col.item.isnme then
					col.item.vy = -col.item.jumpspeed*0.6 -- 0.8, magik XXX, linked to 'stomp'
					col.other.isdirty = true
					col.item.wasup = false -- new 20230315 XXX
				elseif col.other.isplayer1 then
					col.item.vy = -col.item.jumpspeed*0.4
					col.other.isdirty = true
				end
			-- COLLISION FROM BOTTOM
			elseif col.normal.y == 1 then
				if col.other.istunnelfloor then
--					col.item.wasup = false -- new 20230315 XXX
--					col.item.currcoyotetimer = col.item.coyotetimer + 4 -- magik, new 20230315 XXX
--					col.item.vy = -col.item.jumpspeed*0.5
				elseif col.other.isfloor then -- cancel body gravity when hitting from below (can adjust)
--					col.item.vy = 0
					col.item.vy = col.item.vy*0.5
				end
			end
			-- PLAYER1
			if col.item.isplayer1 then
				if col.other.iscollectible then
					col.other.isdirty = true
					if col.other.version == "keyA" then col.item.doorA = true end -- keyA in player1 inventory!
					if col.other.version == "keyB" then col.item.doorB = true end -- keyA in player1 inventory!
					if col.other.version == "keyC" then col.item.doorC = true end -- keyA in player1 inventory!
				end
			end
		end
		--  _____  _    ___     _______ _____ _____  _____ 
		-- |  __ \| |  | \ \   / / ____|_   _/ ____|/ ____|
		-- | |__) | |__| |\ \_/ / (___   | || |    | (___  
		-- |  ___/|  __  | \   / \___ \  | || |     \___ \ 
		-- | |    | |  | |  | |  ____) |_| || |____ ____) |
		-- |_|    |_|  |_|  |_| |_____/|_____\_____|_____/ 
		self.vy += g_gravity * self.currmass
		if self.wasonmvpf then
			self.vy = self.jumpspeed*0.25 -- reset vy, magik XXX
			self.wasonmvpf = false
		end
		if self.currinputbuffer > 0 then -- jump input buffer timer
			self.currinputbuffer -= 1
		end
		if self.currcoyotetimer > 0 then -- coyote timer
			self.currcoyotetimer -= 1
		end
		if self.washurt and self.washurt > 0 then -- hurt fx, work only on player1? XXX
			self.washurt -= 1
			if self.washurt <= 0 then self.sprite:setColorTransform(1, 1, 1, 1) end
		end
		-- IS ON STEP
		if self.isstepcontacts then
--			if self.isplayer1 then print("isonstep", e.deltaTime) end
			if self.isleft and not self.isright then -- LEFT
				self.curranim = g_ANIM_RUN_L
				self.flip = -1
				self.vx = -self.speed
				self.vy = -self.jumpspeed*0.25 -- 0.3, step climb speed here XXX
			elseif self.isright and not self.isleft then -- RIGHT
				self.curranim = g_ANIM_RUN_R
				self.flip = 1
				self.vx = self.speed
				self.vy = -self.jumpspeed*0.25 -- 0.3, step climb speed here XXX
			else
				if self.flip == -1 then self.curranim = g_ANIM_IDLE_L
				else self.curranim = g_ANIM_IDLE_R
				end
				self.vx = 0
			end
			if self.isup and not self.isdown then -- UP
				self.vy = -self.jumpspeed*0.5
				self.isstepcontacts = false
--				self.wasup = true -- commented, new 20230715 XXX
			elseif self.isdown and not self.isup then -- DOWN
			end
		-- IS ON FLOOR
		elseif self.isfloorcontacts and
				not self.iswallcontacts and
				not self.isladdercontacts and
				not self.isptpfcontacts and
				not self.ismvpfcontacts
				then
--			if self.isplayer1 then print("isonfloor", e.deltaTime) end
			if self.isleft and not self.isright then -- LEFT
				self.curranim = g_ANIM_RUN_L
				self.flip = -1
				self.vx = -self.speed
			elseif self.isright and not self.isleft then -- RIGHT
				self.curranim = g_ANIM_RUN_R
				self.flip = 1
				self.vx = self.speed
			else
				if self.flip == -1 then self.curranim = g_ANIM_IDLE_L
				else self.curranim = g_ANIM_IDLE_R
				end
				self.vx = 0
			end
--			if self.isup and not self.isdown and not self.wasup then -- UP old way
--				self.vy = -self.jumpspeed
--				self.wasup = true
--				self.currcoyotetimer = 0 -- prevents double jump when releasing up key in extrafloor area, new 20230715 XXX
			if self.currinputbuffer > 0 and not self.isdown and not self.wasup then -- UP new way
				self.vy = -self.jumpspeed
				self.wasup = true
				self.currinputbuffer = 0 -- win32 discrepency
				self.currcoyotetimer = 0 -- prevents double jump when releasing up key in extrafloor area, new 20230715 XXX
			elseif self.isdown and not self.isup then -- DOWN
			end
		-- IS ON LADDER
		elseif not self.isfloorcontacts and
				not self.iswallcontacts and
				self.isladdercontacts and
				not self.isptpfcontacts and
				not self.ismvpfcontacts
				then
			if not self.isflyingnme then
--				print("isonladder", e.deltaTime)
				if self.isleft and not self.isright then -- LEFT
					self.curranim = g_ANIM_LADDERUP_L
					self.flip = -1
					self.vx = -self.speed*0.5
				elseif self.isright and not self.isleft then -- RIGHT
					self.curranim = g_ANIM_LADDERUP_R
					self.flip = 1
					self.vx = self.speed*0.5
				else
					self.curranim = g_ANIM_LADDERIDLE_L
					if self.flip == 1 then
						self.curranim = g_ANIM_LADDERIDLE_R
					end
					self.vx = 0
				end
				if self.isup and not self.isdown then -- UP
--					print("isonladder u", e.deltaTime)
					self.curranim = g_ANIM_LADDERUP_L
					if self.flip == 1 then
						self.curranim = g_ANIM_LADDERUP_R
					end
					self.vy = -self.jumpspeed*0.1 -- magik XXX
					self.wasup = false -- allows jumping up off ladder
				elseif self.isdown and not self.isup then -- DOWN
--					print("isonladder d", e.deltaTime)
					self.curranim = g_ANIM_LADDERDOWN_L
					if self.flip == 1 then
						self.curranim = g_ANIM_LADDERDOWN_R
					end
					self.vy = self.jumpspeed*0.1 -- magik XXX
	--				self.wasdown = false -- can delete this line?
				else
					self.vy = 0
				end
				self.wasonladder = true
			end
		-- IS ON PTPF
		elseif not self.isfloorcontacts and
				not self.iswallcontacts and
				not self.isladdercontacts and
				self.isptpfcontacts and
				not self.ismvpfcontacts
				then
--			print("isonptpf", e.deltaTime)
			self.wasonladder = false
			if self.isleft and not self.isright then -- LEFT
				self.curranim = g_ANIM_RUN_L
				self.flip = -1
				self.vx = -self.speed
			elseif self.isright and not self.isleft then -- RIGHT
				self.curranim = g_ANIM_RUN_R
				self.flip = 1
				self.vx = self.speed
			else
				if self.flip == -1 then self.curranim = g_ANIM_IDLE_L
				else self.curranim = g_ANIM_IDLE_R
				end
				self.vx = 0
			end
--			if self.isup and not self.isdown and not self.wasup then -- UP old way
--				self.vy = -self.jumpspeed
--				self.wasup = true
			if self.currinputbuffer > 0 and not self.isdown and not self.wasup then -- UP new way
				self.vy = -self.jumpspeed
				self.wasup = true
				self.currinputbuffer = 0 -- win32 discrepency
				self.currcoyotetimer = 0 -- prevents double jump when releasing up key in extrafloor area, new 20230715 XXX
			elseif self.isdown and not self.isup and not self.wasdown then -- DOWN
				self.vy = self.jumpspeed*0.1
				self.wasdown = true
			end
		-- IS ON MVPF
		elseif not self.isfloorcontacts and
				not self.iswallcontacts and
				not self.isladdercontacts and
				not self.isptpfcontacts and
				self.ismvpfcontacts
				then
--			print("isonmvpf", e.deltaTime)
			if self.isleft and not self.isright then -- LEFT
				self.curranim = g_ANIM_WALK_L
				self.flip = -1
			elseif self.isright and not self.isleft then -- RIGHT
				self.curranim = g_ANIM_WALK_R
				self.flip = 1
			else
				if self.flip == -1 then self.curranim = g_ANIM_IDLE_L
				else self.curranim = g_ANIM_IDLE_R
				end
			end
--			if self.isup and not self.isdown and not self.wasup then -- UP old way
--				self.vy = -self.jumpspeed
----				self.wasup = true -- if set to true cannot jump!
			if self.currinputbuffer > 0 and not self.isdown and not self.wasup then -- UP new way
				self.vy = -self.jumpspeed
--				self.wasup = true -- if set to true cannot jump!
				self.currinputbuffer = 0 -- win32 discrepency
			elseif self.isdown and not self.isup and not self.wasdown then -- DOWN
				self.vy = self.jumpspeed*0.1
				self.wasdown = true
			end
			self.wasonmvpf = true
		-- IS ON SPRING
		elseif self.isspringcontacts then -- controllable heights :-)
--			print("isonspring", e.deltaTime)
			if self.isup and not self.isdown then
				self.vy = -self.vy*1.1 -- increase vy
			elseif self.isdown and not self.isup then
				self.vy = -self.vy*0.7 -- decrease vy
			else
				self.vy = -self.vy -- normal vy
--				self.vy = -self.jumpspeed -- normal vy
			end
--			print(self.vy) -- -50 -- cap
			if self.vy > -12 then self.vy = -12
			elseif self.vy < -40 then self.vy = -40
			end
		-- IS IN THE AIR
		else
--			if self.isplayer1 then print("isintheair", e.deltaTime) end
			-- anims
			if self.vy < 0 then -- going UP
				if self.flip == -1 then self.curranim = g_ANIM_JUMPUP_L
				else self.curranim = g_ANIM_JUMPUP_R
				end
			else -- going DOWN
				if self.flip == -1 then self.curranim = g_ANIM_JUMPDOWN_L
				else self.curranim = g_ANIM_JUMPDOWN_R
				end
			end
			-- movements
			if self.isleft and not self.isright then -- LEFT
				self.flip = -1
				self.vx = -self.speed
			elseif self.isright and not self.isleft then -- RIGHT
				self.flip = 1
				self.vx = self.speed
			else
				self.vx = 0
			end
			if self.isup and not self.isdown and not self.wasup then -- UP
				-- coyote time
				if self.currcoyotetimer > 0 then
--					print("isintheair isup", e.deltaTime)
					self.vy = -self.jumpspeed
					self.currcoyotetimer = 0
				end
				self.wasup = true
			elseif self.isdown and not self.isup and not self.wasdown then -- DOWN 'stomp'
				self.vy = self.jumpspeed*0.8 -- magik XXX
				self.wasdown = true
			end
		end
		-- move & flip
		self.x, self.y = nextx, nexty
		self:setPosition(self.x, self.y)
		-- animations
		if self.hasanims then self:playAnim(e.deltaTime) end
		if self.hasLRanims then
			self.bmp:setScale(self.scalex, self.scaley)
		else
			self.bmp:setScale(self.scalex*self.flip, self.scaley)
		end
	end
end

-- animation step1: cut spritesheet and put each image in a table
function SPlayables:cutSpritesheet(xspritesheetpath, xcols, xrows)
	local myanimstex = Texture.new(xspritesheetpath)
	local cellw = myanimstex:getWidth() / xcols
	local cellh = myanimstex:getHeight() / xrows
	self.animsimgs = {}
	for r = 1, xrows do
		for c = 1, xcols do
			local animstexregion = TextureRegion.new(myanimstex, (c - 1) * cellw, (r - 1) * cellh, cellw, cellh)
			self.animsimgs[#self.animsimgs + 1] = animstexregion
		end
	end
	-- this table will hold animations (idle, run, ...) made of images from the animsimgs table
	self.anims = {}
end

-- animation step2: create anims
function SPlayables:createAnim(xanimname, xstart, xfinish)
	self.anims[xanimname] = {} -- create animations tables
	for i = xstart, xfinish do
		self.anims[xanimname][#self.anims[xanimname] + 1] = self.animsimgs[i]
	end
end

-- animation step3: play animations
function SPlayables:playAnim(xdt)
	local checkanim = if self.anims[self.curranim] then self.curranim else g_ANIM_DEFAULT
	self.animtimer = self.animtimer - xdt
	if self.animtimer <= 0 then
		self.frame += 1
		self.animtimer = self.animspeed
		if checkanim == g_ANIM_JUMPUP_L or checkanim == g_ANIM_JUMPDOWN_L or
			checkanim == g_ANIM_JUMPUP_R or checkanim == g_ANIM_JUMPDOWN_R then -- new 20221129 XXX
			if self.frame > #self.anims[checkanim] then
				self.frame = #self.anims[checkanim]
			end
		else
			if self.isplayer1 and (self.curranim == g_ANIM_RUN_L or self.curranim == g_ANIM_RUN_R) and
				(self.frame == 4 or self.frame == 9) then
--					self.channel = self.sndstepgrass:play()
--					if self.channel then self.channel:setVolume(0.2) end
			end
			if self.frame > #self.anims[checkanim] then
				self.frame = 1
			end
		end
		self.bmp:setTextureRegion(self.anims[checkanim][self.frame])
	end
end
