--!NEEDS:splayables.lua

SWalkingNme = Core.class(SPlayables) -- put in lists please!

function SWalkingNme:init(xcworld, xparams, xparams2)
	self.cworld = xcworld
	-- system
	self.isnme = true
	self.iswalkingnme = true
	-- params2
	local params2 = xparams2 or {}
	params2.breed = xparams2.breed or nil
	params2.totallives = xparams2.totallives or 3
	params2.defaultmass = xparams2.defaultmass or 0.45
	params2.scalex = xparams2.scalex or 1
	params2.scaley = xparams2.scaley or params2.scalex
	params2.flip = xparams2.flip or 1
	params2.speed = xparams2.speed or 1
	params2.jumpspeed = xparams2.jumpspeed or 8
	params2.coyotetimer = xparams2.coyotetimer or 12
	params2.animspeed = xparams2.animspeed or 1/16
	params2.dx = xparams2.dx or 64*100
	params2.direction = xparams2.direction or nil
	params2.dokeep = xparams2.dokeep or nil
	params2.doshoot = if xparams2.doshoot ~= nil then xparams2.doshoot else false -- luau ternary operator
	-- self
	self.breed = params2.breed
	self.totallives = params2.totallives
	self.currlives = self.totallives
	self.defaultmass = params2.defaultmass
	self.currmass = self.defaultmass
	self.scalex = params2.scalex
	self.scaley = params2.scaley
	self.flip = params2.flip
	self.speed = params2.speed
	self.jumpspeed = params2.jumpspeed
	self.inputbuffer = 6 -- new 20230731
	self.currinputbuffer = 0 -- new 20230731
	self.coyotetimer = params2.coyotetimer
	self.currcoyotetimer = self.coyotetimer
	self.vx = 0 -- for left/right movement
	self.vy = 0 -- for up/down movement & gravity
	self.dokeep = params2.dokeep -- do keep sprite when deaded?
	-- animation step2: create anims
	for i = 1, #xparams2.animations do
		SPlayables.createAnim(
			self,
			xparams2.animations[i][1], -- anim name
			xparams2.animations[i][2], -- anim start
			xparams2.animations[i][3] -- anim end
		)
	end
	-- animations
	self.hasanims = true
	self.hasLRanims = false -- allows to have L and R animations (note: must be for all animations!)
	self.curranim = ""
	self.frame = 0
	self.animspeed = params2.animspeed
	self.animtimer = self.animspeed
	-- ai
	self.startpositionx = self.x
	self.startpositiony = self.y
	self.dx = params2.dx
	-- the bitmap
	self.bmp = Bitmap.new(self.animsimgs[1]) -- starting bmp texture (from playables class)
	self.bmp:setAnchorPoint(0.5, 0.5)
	self.bmp:setScale(self.scalex, self.scaley)
	self.w = self.bmp:getWidth() / 2
	self.h = self.bmp:getHeight()
	print("SWalkingNme size:", self.w, self.h)
	-- set position inside sprite
	self.bmp:setPosition(self.w / 2, self.h / 2)
	-- our sprite is ready
	self.sprite = Sprite.new()
	self.sprite:addChild(self.bmp)
	if xparams2.sdebug then
		local mypixel = Pixel.new(xparams2.sdebug, 0.4, self.w, self.h) -- collisions debugging
		self.sprite:addChild(mypixel) -- debug
	end
	self:addChild(self.sprite)
	-- shoot
	if params2.doshoot then
		self.doshoot = params2.doshoot
		self.shoottime = 0
	end
	-- listeners
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
	-- let's move!
	if params2.direction == "l" then self.isleft = true self.isright = false
	else self.isleft = false self.isright = true
	end
end

-- game loop
local visibilitydist = myappwidth*1.5
local dx, dy
local player1
function SWalkingNme:onEnterFrame(e)
	player1 = self.cworld.player1
	for i = #self.cworld.walkingnmes, 1, -1 do
		dx, dy = self.cworld.walkingnmes[i].x - player1.x, self.cworld.walkingnmes[i].y - player1.y
		if (((dx * dx) + (dy * dy)) ^0.5) < visibilitydist then
			if self.cworld.walkingnmes[i].isdirty and self.cworld.walkingnmes[i].currlives > 0 then
				-- isdirty
				self.cworld.walkingnmes[i].currlives -= 1
				self.cworld.walkingnmes[i].washurt = 20 -- hurt timer
				self.cworld.walkingnmes[i].sprite:setColorTransform(2, 0.5, 0.5, 1) -- hurt fx
				self.cworld.walkingnmes[i].isdirty = false
				if self.cworld.walkingnmes[i].currlives <= 0 then -- deaded
					self.cworld.walkingnmes[i].isactive = false
--					self.cworld.walkingnmes[i].curranim = g_ANIM_LOSE1_R
					if self.cworld.walkingnmes[i].dokeep then self.cworld.walkingnmes[i].sprite:setAlpha(0.3) -- keep sprite
					else self.cworld.walkingnmes[i].sprite:getParent():removeChild(self.cworld.walkingnmes[i].sprite) -- remove sprite from layer (or not)
					end
					self.cworld:remove(self.cworld.walkingnmes[i]) -- remove from cbump world
					self.cworld.walkingnmes[i] = nil -- 1 remove from list
					table.remove(self.cworld.walkingnmes, i) -- 2 remove from list
					-- revenge
					for i = #self.cworld.walkingnmes, 1, -1 do
						self.cworld.walkingnmes[i].doshoot = true
						self.cworld.walkingnmes[i].shoottime = 0
					end
				end
			else
				-- action
				if self.cworld.walkingnmes[i].currlives > 0 then
					self.cworld.walkingnmes[i].isactive = true
					-- AI
					if self.cworld.walkingnmes[i].dx then -- change direction when reaching dx limits
						if self.cworld.walkingnmes[i].x < self.cworld.walkingnmes[i].startpositionx - self.cworld.walkingnmes[i].dx then
							self.cworld.walkingnmes[i].isleft, self.cworld.walkingnmes[i].isright =
								false, true
						elseif self.cworld.walkingnmes[i].x > self.cworld.walkingnmes[i].startpositionx then
							self.cworld.walkingnmes[i].isleft, self.cworld.walkingnmes[i].isright =
								true, false
						end
					end
					-- shoot
					if self.cworld.walkingnmes[i].doshoot and (((dx * dx) + (dy * dy)) ^0.5) < visibilitydist*0.6 then
						if self.cworld.walkingnmes[i].flip == 1 and (self.cworld.walkingnmes[i].x <= player1.x) or
							self.cworld.walkingnmes[i].flip == -1 and (self.cworld.walkingnmes[i].x > player1.x) then
							self.cworld.walkingnmes[i].shoottime += 1
							if self.cworld.walkingnmes[i].shoottime > 32*10 then -- magik XXX
--								dosound(self.sndshoot)
--								self.cworld.walkingnmes[i]:shoot(self.cworld.walkingnmes[i])
								Core.asyncCall(self.shoot, self.cworld.walkingnmes[i], self.cworld.walkingnmes[i])
								self.cworld.walkingnmes[i].shoottime = 0
							end
						end
					end
				end
			end
		else
			self.cworld.walkingnmes[i].isactive = false
		end
	end
end

-- shoot
function SWalkingNme:shoot(xnme)
	local texpath = "gfx/projectiles/ball05_0007.png"
	local scalex, scaley = 1.4, 1.4
	local defaultmass = 0.1
	local speed, jumpspeed = 8*2, -8*1.2
	local range = 64*24
	if self.breed == "B" then
		scalex, scaley = 1.4, 1.4
		defaultmass = 0.07
		speed, jumpspeed = 8*2, -8*0.5
		range = 64*24
	elseif self.breed == "C" then
		scalex, scaley = 1.4, 1.4
		defaultmass = 0.1
		speed, jumpspeed = 8*1, 8*0.7
		range = 64*24
	end
	local myshape = SProjectile.new(self.cworld,
		{
			texpath=texpath,
			a=0.7,
			defaultmass=defaultmass,
			x=xnme.x + xnme.w/4, y=xnme.y + xnme.h/2,
			scalex=scalex, scaley=scaley,
			flip=self.flip,
			speed=speed, jumpspeed=jumpspeed,
			range=range,
--			sdebug=0xff0000,
		}
	)
	myshape.iseprojectile = true -- ECS id, IMPORTANT! XXX
	self.cworld.projectileslayer:addChild(myshape) -- layer
end
